/* eslint-disable */
/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */
import { HTMLStencilElement, JSXBase } from "./stencil-public-runtime";
import { AuthState, AuthStateHandler, CognitoUserInterface, FederatedConfig, MFATypesInterface, UsernameAliasStrings } from "./common/types/auth-types";
import { FormFieldTypes } from "./components/amplify-auth-fields/amplify-auth-fields-interface";
import { ButtonTypes, ButtonVariant, InputEvent, TextFieldTypes } from "./common/types/ui-types";
import { IconNameType } from "./components/amplify-icon/icons";
import { ChatResult } from "./common/types/interactions-types";
import { FunctionalComponent } from "./stencil-public-runtime";
import { CountryCodeDialOptions } from "./components/amplify-country-dial-code/amplify-country-dial-code-interface";
import { AccessLevel, StorageObject } from "./common/types/storage-types";
import { SelectOptionsNumber, SelectOptionsString } from "./components/amplify-select/amplify-select-interface";
import { SignUpParams } from "@aws-amplify/auth";
import { ISignUpResult } from "amazon-cognito-identity-js";
export namespace Components {
    interface AmplifyAmazonButton {
        /**
          * App-specific client ID from Google
         */
        "clientId": FederatedConfig['amazonClientId'];
        /**
          * Auth state change handler for this component e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange": AuthStateHandler;
    }
    interface AmplifyAuthContainer {
    }
    interface AmplifyAuthFields {
        /**
          * Form fields allows you to utilize our pre-built components such as username field, code field, password field, email field, etc. by passing an array of strings that you would like the order of the form to be in. If you need more customization, such as changing text for a label or adjust a placeholder, you can follow the structure below in order to do just that. ``` [   {     type: string,     label: string,     placeholder: string,     hint: string | Functional Component | null,     required: boolean   } ] ```
         */
        "formFields": FormFieldTypes | string[];
    }
    interface AmplifyAuth0Button {
        /**
          * See: https://auth0.com/docs/libraries/auth0js/v9#available-parameters
         */
        "config": FederatedConfig['auth0Config'];
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange": AuthStateHandler;
    }
    interface AmplifyAuthenticator {
        /**
          * Federated credentials & configuration.
         */
        "federated": FederatedConfig;
        /**
          * Callback for Authenticator state machine changes
         */
        "handleAuthStateChange": AuthStateHandler;
        /**
          * Hide amplify-toast for auth errors
         */
        "hideToast": boolean;
        /**
          * Initial starting state of the Authenticator component. E.g. If `signup` is passed the default component is set to AmplifySignUp
         */
        "initialAuthState": | AuthState.SignIn
		| AuthState.SignUp
		| AuthState.ForgotPassword;
        /**
          * Username Alias is used to setup authentication with `username`, `email` or `phone_number`
         */
        "usernameAlias": UsernameAliasStrings;
    }
    interface AmplifyButton {
        /**
          * Disabled state of the button
         */
        "disabled"?: boolean;
        /**
          * (Optional) Callback called when a user clicks on the button
         */
        "handleButtonClick": (evt: Event) => void;
        /**
          * Name of icon to be placed inside the button
         */
        "icon"?: IconNameType;
        /**
          * Type of the button: 'button', 'submit' or 'reset'
         */
        "type": ButtonTypes;
        /**
          * Variant of a button: 'button' | 'anchor | 'icon'
         */
        "variant": ButtonVariant;
    }
    interface AmplifyChatbot {
        /**
          * Name of the bot
         */
        "botName": string;
        /**
          * Text placed in the top header
         */
        "botTitle": string;
        /**
          * Clear messages when conversation finishes
         */
        "clearOnComplete": boolean;
        /**
          * Continue listening to users after they send the message
         */
        "conversationModeOn": boolean;
        /**
          * Noise threshold between -1 and 1. Anything below is considered a silence.
         */
        "silenceThreshold": number;
        /**
          * Amount of silence (in ms) to wait for
         */
        "silenceTime": number;
        /**
          * Whether text chat is enabled
         */
        "textEnabled": boolean;
        /**
          * Whether voice chat is enabled
         */
        "voiceEnabled": boolean;
        /**
          * Greeting message displayed to users
         */
        "welcomeMessage": string;
    }
    interface AmplifyCheckbox {
        /**
          * If `true`, the checkbox is selected.
         */
        "checked": boolean;
        /**
          * If `true`, the checkbox is disabled
         */
        "disabled": boolean;
        /**
          * Field ID used for the 'htmlFor' in the label
         */
        "fieldId": string;
        /**
          * Label for the checkbox
         */
        "label": string;
        /**
          * Name of the checkbox
         */
        "name"?: string;
        /**
          * Value of the checkbox
         */
        "value"?: string;
    }
    interface AmplifyCodeField {
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * Based on the type of field e.g. sign in, sign up, forgot password, etc.
         */
        "fieldId": string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Used as the hint in case you forgot your confirmation code, etc.
         */
        "hint": string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Used for the code label
         */
        "label": string;
        /**
          * Used for the placeholder label
         */
        "placeholder": string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required": boolean;
        /**
          * The value of the content inside of the input field
         */
        "value"?: string;
    }
    interface AmplifyConfirmSignIn {
        /**
          * Form fields allows you to utilize our pre-built components such as username field, code field, password field, email field, etc. by passing an array of strings that you would like the order of the form to be in. If you need more customization, such as changing text for a label or adjust a placeholder, you can follow the structure below in order to do just that. ``` [   {     type: string,     label: string,     placeholder: string,     hint: string | Functional Component | null,     required: boolean   } ] ```
         */
        "formFields": FormFieldTypes | string[];
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange": AuthStateHandler;
        /**
          * Fires when confirm sign in form is submitted
         */
        "handleSubmit": (event: Event) => void;
        /**
          * Used for header text in confirm sign in component
         */
        "headerText": string;
        /**
          * Used for the submit button text in confirm sign in component
         */
        "submitButtonText": string;
        /**
          * Cognito user signing in
         */
        "user": CognitoUserInterface;
    }
    interface AmplifyConfirmSignUp {
        /**
          * Form fields allows you to utilize our pre-built components such as username field, code field, password field, email field, etc. by passing an array of strings that you would like the order of the form to be in. If you need more customization, such as changing text for a label or adjust a placeholder, you can follow the structure below in order to do just that. ``` [   {     type: string,     label: string,     placeholder: string,     hint: string | Functional Component | null,     required: boolean   } ] ```
         */
        "formFields": FormFieldTypes | string[];
        /**
          * Auth state change handler for this components e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange": AuthStateHandler;
        /**
          * Fires when sign up form is submitted
         */
        "handleSubmit": (submitEvent: Event) => void;
        /**
          * Used for header text in confirm sign up component
         */
        "headerText": string;
        /**
          * Used for the submit button text in confirm sign up component
         */
        "submitButtonText": string;
        /**
          * Used for the username to be passed to resend code
         */
        "user": CognitoUserInterface;
        /**
          * Username Alias is used to setup authentication with `username`, `email` or `phone_number`
         */
        "usernameAlias": UsernameAliasStrings;
    }
    interface AmplifyContainer {
    }
    interface AmplifyCountryDialCode {
        /**
          * Default selected dial code
         */
        "dialCode": string | number;
        /**
          * The ID of the field.  Should match with its corresponding input's ID.
         */
        "fieldId": string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * The options of the country dial code select input.
         */
        "options": CountryCodeDialOptions;
    }
    interface AmplifyEmailField {
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * Based on the type of field e.g. sign in, sign up, forgot password, etc.
         */
        "fieldId": string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Used for the hint text that displays underneath the input field
         */
        "hint"?: string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Used for the EMAIL label
         */
        "label": string;
        /**
          * Used for the placeholder label
         */
        "placeholder": string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required": boolean;
        /**
          * The value of the content inside of the input field
         */
        "value"?: string;
    }
    interface AmplifyFacebookButton {
        /**
          * App-specific client ID from Facebook
         */
        "appId": FederatedConfig['facebookAppId'];
        /**
          * Auth state change handler for this component e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange": AuthStateHandler;
    }
    interface AmplifyFederatedButtons {
        /**
          * The current authentication state.
         */
        "authState": AuthState;
        /**
          * Federated credentials & configuration.
         */
        "federated": FederatedConfig;
        /**
          * Auth state change handler for this component e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange": AuthStateHandler;
    }
    interface AmplifyFederatedSignIn {
        /**
          * The current authentication state.
         */
        "authState": AuthState;
        /**
          * Federated credentials & configuration.
         */
        "federated": any;
    }
    interface AmplifyForgotPassword {
        /**
          * The form fields displayed inside of the forgot password form
         */
        "formFields": FormFieldTypes | string[];
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange": AuthStateHandler;
        /**
          * The function called when making a request to reset password
         */
        "handleSend": (event: Event) => void;
        /**
          * The function called when submitting a new password
         */
        "handleSubmit": (event: Event) => void;
        /**
          * The header text of the forgot password section
         */
        "headerText": string;
        /**
          * The text displayed inside of the send code button for the form
         */
        "sendButtonText": string;
        /**
          * The text displayed inside of the submit button for the form
         */
        "submitButtonText": string;
        /**
          * Username Alias is used to setup authentication with `username`, `email` or `phone_number`
         */
        "usernameAlias": UsernameAliasStrings;
    }
    interface AmplifyFormField {
        /**
          * The text of the description.  Goes between the label and the input.
         */
        "description": string | null;
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * The ID of the field. Should match with its corresponding input's ID.
         */
        "fieldId": string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * The text of a hint to the user as to how to fill out the input. Goes just below the input.
         */
        "hint": string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * The text of the label. Goes above the input. Ex: 'First name'
         */
        "label": string | null;
        /**
          * (Optional) String value for the name of the input.
         */
        "name"?: string;
        /**
          * (Optional) The placeholder for the input element.  Using hints is recommended, but placeholders can also be useful to convey information to users.
         */
        "placeholder"?: string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required": boolean;
        /**
          * The input type.  Can be any HTML input type.
         */
        "type"?: TextFieldTypes;
        /**
          * The value of the content inside of the input field
         */
        "value": string;
    }
    interface AmplifyFormSection {
        /**
          * (Required) Function called upon submission of form
         */
        "handleSubmit": (event: Event) => void;
        /**
          * Used for form section header
         */
        "headerText": string;
        /**
          * Loading state for the form
         */
        "loading"?: boolean;
        /**
          * Secondary footer component or text
         */
        "secondaryFooterContent": string | FunctionalComponent | null;
        /**
          * (Optional) Used as a the default value within the default footer slot
         */
        "submitButtonText"?: string;
        /**
          * String prefix for the data-test attributes in this component primarily used for testing purposes
         */
        "testDataPrefix"?: string;
    }
    interface AmplifyGoogleButton {
        /**
          * App-specific client ID from Google
         */
        "clientId": FederatedConfig['googleClientId'];
        /**
          * Auth state change handler for this component e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange": AuthStateHandler;
    }
    interface AmplifyGreetings {
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange": AuthStateHandler;
        /**
          * Logo displayed inside of the header
         */
        "logo": FunctionalComponent | null;
        /**
          * Username displayed in the greetings
         */
        "username": string;
    }
    interface AmplifyHint {
    }
    interface AmplifyIcon {
        /**
          * (Required) Name of icon used to determine the icon rendered
         */
        "name": IconNameType;
    }
    interface AmplifyIconButton {
        /**
          * (Optional) Whether or not to show the tooltip automatically
         */
        "autoShowTooltip": boolean;
        /**
          * The name of the icon used inside of the button
         */
        "name": IconNameType;
        /**
          * (Optional) The tooltip that will show on hover of the button
         */
        "tooltip": string | null;
    }
    interface AmplifyInput {
        /**
          * The text of the description.  Goes just below the label.
         */
        "description": string | null;
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * The ID of the field.  Should match with its corresponding input's ID.
         */
        "fieldId": string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: InputEvent) => void;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * (Optional) String value for the name of the input.
         */
        "name"?: string;
        /**
          * (Optional) The placeholder for the input element.  Using hints is recommended, but placeholders can also be useful to convey information to users.
         */
        "placeholder"?: string;
        /**
          * Whether the input is a required field
         */
        "required"?: boolean;
        /**
          * The input type.  Can be any HTML input type.
         */
        "type"?: TextFieldTypes;
        /**
          * The value of the content inside of the input field
         */
        "value": string;
    }
    interface AmplifyLabel {
        /**
          * Reflects the value of the for content property of html element
         */
        "htmlFor": string;
    }
    interface AmplifyLink {
        /**
          * The link role is used to identify an element that creates a hyperlink to a resource that is in the application or external
         */
        "role": string;
    }
    interface AmplifyLoadingSpinner {
    }
    interface AmplifyNav {
    }
    interface AmplifyOauthButton {
        /**
          * Federated credentials & configuration.
         */
        "config": FederatedConfig['oauthConfig'];
    }
    interface AmplifyPasswordField {
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * Based on the type of field e.g. sign in, sign up, forgot password, etc.
         */
        "fieldId": string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Used as the hint in case you forgot your password, etc.
         */
        "hint": string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Used for the password label
         */
        "label": string;
        /**
          * Used for the placeholder label
         */
        "placeholder": string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required": boolean;
        /**
          * The value of the content inside of the input field
         */
        "value"?: string;
    }
    interface AmplifyPhoneField {
        /**
          * Default dial code in the phone field
         */
        "dialCode"?: string | number;
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * Based on the type of field e.g. sign in, sign up, forgot password, etc.
         */
        "fieldId": string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Used as the hint in case you forgot your confirmation code, etc.
         */
        "hint": string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Used for the Phone label
         */
        "label": string;
        /**
          * Used for the placeholder label
         */
        "placeholder": string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required": boolean;
        /**
          * The value of the content inside of the input field
         */
        "value": string;
    }
    interface AmplifyPhotoPicker {
        /**
          * Picker button text as string
         */
        "buttonText"?: string;
        /**
          * Function that handles file pick onClick
         */
        "handleClick"?: (file: File) => void;
        /**
          * Header Hint value in string
         */
        "headerHint"?: string;
        /**
          * Title string value
         */
        "headerTitle"?: string;
        /**
          * Placeholder hint that goes under the placeholder image
         */
        "placeholderHint"?: string;
        /**
          * Source of the image to be previewed
         */
        "previewSrc"?: string | object;
    }
    interface AmplifyPicker {
        /**
          * File input accept value
         */
        "acceptValue": string;
        /**
          * File input onChange handler
         */
        "inputHandler": (e: Event) => void;
        /**
          * Picker button text
         */
        "pickerText": string;
    }
    interface AmplifyRadioButton {
        /**
          * If `true`, the radio button is selected.
         */
        "checked": boolean;
        /**
          * If `true`, the checkbox is disabled
         */
        "disabled": boolean;
        /**
          * Field ID used for the 'for' in the label
         */
        "fieldId": string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Label for the radio button
         */
        "label": string;
        /**
          * (Optional) Name of radio button
         */
        "name"?: string;
        /**
          * (Optional) The placeholder for the input element.  Using hints is recommended, but placeholders can also be useful to convey information to users.
         */
        "placeholder"?: string;
        /**
          * (Optional) Value of radio button
         */
        "value"?: string;
    }
    interface AmplifyRequireNewPassword {
        /**
          * The form fields displayed inside of the forgot password form
         */
        "formFields": FormFieldTypes;
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange": AuthStateHandler;
        /**
          * The function called when submitting a new password
         */
        "handleSubmit": (event: Event) => void;
        /**
          * The header text of the forgot password section
         */
        "headerText": string;
        /**
          * The text displayed inside of the submit button for the form
         */
        "submitButtonText": string;
        /**
          * Used for the username to be passed to resend code
         */
        "user": CognitoUserInterface;
    }
    interface AmplifyS3Album {
        /**
          * The content type header used when uploading to S3
         */
        "contentType": string;
        /**
          * Callback used to generate custom key value
         */
        "fileToKey": (data: object) => string | string;
        /**
          * Filter to be applied on album list
         */
        "filter": (list: StorageObject[]) => StorageObject[];
        /**
          * Function executed when error occurs for the s3-image
         */
        "handleOnError": (event: Event) => void;
        /**
          * Function executed when s3-image loads
         */
        "handleOnLoad": (event: Event) => void;
        /**
          * Cognito identity id of the another user's image list
         */
        "identityId": string;
        /**
          * The access level of the files
         */
        "level": AccessLevel;
        /**
          * String representing directory location of image files to be listed
         */
        "path": string;
        /**
          * Boolean to enable or disable picker
         */
        "picker": boolean;
        /**
          * Picker button text
         */
        "pickerText": string;
        /**
          * Sort to be applied on album list
         */
        "sort": (list: StorageObject[]) => StorageObject[];
        /**
          * Whether or not to use track the get/put of the listing of images
         */
        "track": boolean;
    }
    interface AmplifyS3Image {
        /**
          * String representing the alternate image text
         */
        "alt": string;
        /**
          * Image body content to be uploaded
         */
        "body": object;
        /**
          * The content type header used when uploading to S3
         */
        "contentType": string;
        /**
          * Function executed when error occurs for the image
         */
        "handleOnError": (event: Event) => void;
        /**
          * Function executed when image loads
         */
        "handleOnLoad": (event: Event) => void;
        /**
          * Cognito identity id of the another user's image
         */
        "identityId": string;
        /**
          * The key of the image object in S3
         */
        "imgKey": string;
        /**
          * Attributes to be placed on the img element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/img#attributes
         */
        "imgProps"?: Record<PropertyKey, any>;
        /**
          * The access level of the image
         */
        "level": AccessLevel;
        /**
          * String representing directory location to image file
         */
        "path": string;
        /**
          * Whether or not to use track on get/put of the image
         */
        "track": boolean;
    }
    interface AmplifyS3ImagePicker {
        /**
          * Upload Button Text as string
         */
        "buttonText"?: string;
        /**
          * The content type header used when uploading to S3
         */
        "contentType": string;
        /**
          * Callback used to generate custom key value
         */
        "fileToKey": (data: object) => string | string;
        /**
          * Header Hint value in string
         */
        "headerHint"?: string;
        /**
          * Title string value
         */
        "headerTitle"?: string;
        /**
          * Cognito identity id of the another user's image
         */
        "identityId": string;
        /**
          * The access level of the image
         */
        "level": AccessLevel;
        /**
          * String representing directory location to image file
         */
        "path": string;
        /**
          * Placeholder hint that goes under the placeholder image
         */
        "placeholderHint"?: string;
        /**
          * Whether or not to use track the get/put of the image
         */
        "track": boolean;
    }
    interface AmplifyS3Text {
        /**
          * Text body content to be uploaded
         */
        "body": object;
        /**
          * The content type header used when uploading to S3
         */
        "contentType": string;
        /**
          * Fallback content
         */
        "fallbackText": string;
        /**
          * Cognito identity id of the another user's text file
         */
        "identityId": string;
        /**
          * The access level of the text file
         */
        "level": AccessLevel;
        /**
          * String representing directory location to text file
         */
        "path": string;
        /**
          * The key of the text object in S3
         */
        "textKey": string;
        /**
          * Whether or not to use track the get/put of the text file
         */
        "track": boolean;
    }
    interface AmplifyS3TextPicker {
        /**
          * The content type header used when uploading to S3
         */
        "contentType": string;
        /**
          * Fallback content for aplify-s3-text
         */
        "fallbackText": string;
        /**
          * Callback used to generate custom key value
         */
        "fileToKey": (data: object) => string | string;
        /**
          * Cognito identity id of the another user's text file
         */
        "identityId": string;
        /**
          * The access level of the text file
         */
        "level": AccessLevel;
        /**
          * String representing directory location to text file
         */
        "path": string;
        /**
          * Whether or not to use track the get/put of the text file
         */
        "track": boolean;
    }
    interface AmplifySection {
        /**
          * Equivalent to html section role
         */
        "role": string;
    }
    interface AmplifySelect {
        /**
          * Used for id field
         */
        "fieldId": string;
        /**
          * The callback, called when the select is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * The options of the select input. Must be an Array of Objects with an Object shape of {label: string, value: string|number}
         */
        "options": | SelectOptionsString
		| SelectOptionsNumber;
        /**
          * Default selected option
         */
        "selected"?: string | number;
    }
    interface AmplifySelectMfaType {
        /**
          * Types of MFA options
         */
        "MFATypes": MFATypesInterface;
        /**
          * Current authenticated user in order to sign requests properly for TOTP
         */
        "authData": CognitoUserInterface;
        /**
          * Fires when Verify is clicked
         */
        "handleSubmit": (event: Event) => void;
    }
    interface AmplifySignIn {
        /**
          * Federated credentials & configuration.
         */
        "federated": FederatedConfig;
        /**
          * Form fields allows you to utilize our pre-built components such as username field, code field, password field, email field, etc. by passing an array of strings that you would like the order of the form to be in. If you need more customization, such as changing text for a label or adjust a placeholder, you can follow the structure below in order to do just that. ``` [   {     type: string,     label: string,     placeholder: string,     hint: string | Functional Component | null,     required: boolean   } ] ```
         */
        "formFields": FormFieldTypes | string[];
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange": AuthStateHandler;
        /**
          * Fires when sign in form is submitted
         */
        "handleSubmit": (event: Event) => void;
        /**
          * Used for header text in sign in component
         */
        "headerText": string;
        /**
          * Hides the sign up link
         */
        "hideSignUp": boolean;
        /**
          * Used for the submit button text in sign in component
         */
        "submitButtonText": string;
        /**
          * Username Alias is used to setup authentication with `username`, `email` or `phone_number`
         */
        "usernameAlias": UsernameAliasStrings;
    }
    interface AmplifySignInButton {
        /**
          * Specifies the federation provider.
         */
        "provider": 'amazon' | 'auth0' | 'facebook' | 'google' | 'oauth';
    }
    interface AmplifySignOut {
        /**
          * Text inside of the Sign Out button
         */
        "buttonText": string;
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange": AuthStateHandler;
    }
    interface AmplifySignUp {
        /**
          * Form fields allows you to utilize our pre-built components such as username field, code field, password field, email field, etc. by passing an array of strings that you would like the order of the form to be in. If you need more customization, such as changing text for a label or adjust a placeholder, you can follow the structure below in order to do just that. ``` [   {     type: string,     label: string,     placeholder: string,     hint: string | Functional Component | null,     required: boolean   } ] ```
         */
        "formFields": FormFieldTypes | string[];
        /**
          * Auth state change handler for this component e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange": AuthStateHandler;
        /**
          * Override for handling the Auth.SignUp API call
         */
        "handleSignUp": (
		params: SignUpParams
	) => Promise<ISignUpResult>;
        /**
          * Fires when sign up form is submitted
         */
        "handleSubmit": (event: Event) => void;
        /**
          * Used for the submit button text in sign up component
         */
        "haveAccountText": string;
        /**
          * Used for header text in sign up component
         */
        "headerText": string;
        /**
          * Text used for the sign in hyperlink
         */
        "signInText": string;
        /**
          * Used for the submit button text in sign up component
         */
        "submitButtonText": string;
        /**
          * Username Alias is used to setup authentication with `username`, `email` or `phone_number`
         */
        "usernameAlias": UsernameAliasStrings;
        /**
          * Engages when invalid actions occur, such as missing field, etc.
         */
        "validationErrors": string;
    }
    interface AmplifyStrike {
    }
    interface AmplifyToast {
        /**
          * Used in order to add a dismissable `x` for the Toast component
         */
        "handleClose": () => void;
        /**
          * Message to be displayed inside the toast
         */
        "message": string;
    }
    interface AmplifyTooltip {
        /**
          * (Optional) Whether or not the tooltip should be automatically shown, i.e. not disappear when not hovered
         */
        "shouldAutoShow": boolean;
        /**
          * (Required) The text in the tooltip
         */
        "text": string;
    }
    interface AmplifyTotpSetup {
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange": AuthStateHandler;
        /**
          * This is run after totp setup is complete. Useful if using this as standalone.
         */
        "handleComplete": (
		user: CognitoUserInterface
	) => void | Promise<void>;
        /**
          * Used for header text in totp setup component
         */
        "headerText": string;
        /**
          * Used for customizing the issuer string in the qr code image
         */
        "issuer": string;
        /**
          * Set this to true if this component is running outside the default `amplify-authenticator` usage
         */
        "standalone": boolean;
        /**
          * Used in order to configure TOTP for a user
         */
        "user": CognitoUserInterface;
    }
    interface AmplifyUsernameField {
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * Based on the type of field e.g. sign in, sign up, forgot password, etc.
         */
        "fieldId": string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Used for the hint text that displays underneath the input field
         */
        "hint"?: string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Used for the username label
         */
        "label": string;
        /**
          * Used for the placeholder label
         */
        "placeholder": string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required": boolean;
        /**
          * The value of the content inside of the input field
         */
        "value"?: string;
    }
    interface AmplifyVerifyContact {
        /**
          * Authentication state handler
         */
        "handleAuthStateChange": AuthStateHandler;
        /**
          * User with unverified contact information
         */
        "user": CognitoUserInterface;
    }
}
declare global {
    interface HTMLAmplifyAmazonButtonElement extends Components.AmplifyAmazonButton, HTMLStencilElement {
    }
    var HTMLAmplifyAmazonButtonElement: {
        prototype: HTMLAmplifyAmazonButtonElement;
        new (): HTMLAmplifyAmazonButtonElement;
    };
    interface HTMLAmplifyAuthContainerElement extends Components.AmplifyAuthContainer, HTMLStencilElement {
    }
    var HTMLAmplifyAuthContainerElement: {
        prototype: HTMLAmplifyAuthContainerElement;
        new (): HTMLAmplifyAuthContainerElement;
    };
    interface HTMLAmplifyAuthFieldsElement extends Components.AmplifyAuthFields, HTMLStencilElement {
    }
    var HTMLAmplifyAuthFieldsElement: {
        prototype: HTMLAmplifyAuthFieldsElement;
        new (): HTMLAmplifyAuthFieldsElement;
    };
    interface HTMLAmplifyAuth0ButtonElement extends Components.AmplifyAuth0Button, HTMLStencilElement {
    }
    var HTMLAmplifyAuth0ButtonElement: {
        prototype: HTMLAmplifyAuth0ButtonElement;
        new (): HTMLAmplifyAuth0ButtonElement;
    };
    interface HTMLAmplifyAuthenticatorElement extends Components.AmplifyAuthenticator, HTMLStencilElement {
    }
    var HTMLAmplifyAuthenticatorElement: {
        prototype: HTMLAmplifyAuthenticatorElement;
        new (): HTMLAmplifyAuthenticatorElement;
    };
    interface HTMLAmplifyButtonElement extends Components.AmplifyButton, HTMLStencilElement {
    }
    var HTMLAmplifyButtonElement: {
        prototype: HTMLAmplifyButtonElement;
        new (): HTMLAmplifyButtonElement;
    };
    interface HTMLAmplifyChatbotElement extends Components.AmplifyChatbot, HTMLStencilElement {
    }
    var HTMLAmplifyChatbotElement: {
        prototype: HTMLAmplifyChatbotElement;
        new (): HTMLAmplifyChatbotElement;
    };
    interface HTMLAmplifyCheckboxElement extends Components.AmplifyCheckbox, HTMLStencilElement {
    }
    var HTMLAmplifyCheckboxElement: {
        prototype: HTMLAmplifyCheckboxElement;
        new (): HTMLAmplifyCheckboxElement;
    };
    interface HTMLAmplifyCodeFieldElement extends Components.AmplifyCodeField, HTMLStencilElement {
    }
    var HTMLAmplifyCodeFieldElement: {
        prototype: HTMLAmplifyCodeFieldElement;
        new (): HTMLAmplifyCodeFieldElement;
    };
    interface HTMLAmplifyConfirmSignInElement extends Components.AmplifyConfirmSignIn, HTMLStencilElement {
    }
    var HTMLAmplifyConfirmSignInElement: {
        prototype: HTMLAmplifyConfirmSignInElement;
        new (): HTMLAmplifyConfirmSignInElement;
    };
    interface HTMLAmplifyConfirmSignUpElement extends Components.AmplifyConfirmSignUp, HTMLStencilElement {
    }
    var HTMLAmplifyConfirmSignUpElement: {
        prototype: HTMLAmplifyConfirmSignUpElement;
        new (): HTMLAmplifyConfirmSignUpElement;
    };
    interface HTMLAmplifyContainerElement extends Components.AmplifyContainer, HTMLStencilElement {
    }
    var HTMLAmplifyContainerElement: {
        prototype: HTMLAmplifyContainerElement;
        new (): HTMLAmplifyContainerElement;
    };
    interface HTMLAmplifyCountryDialCodeElement extends Components.AmplifyCountryDialCode, HTMLStencilElement {
    }
    var HTMLAmplifyCountryDialCodeElement: {
        prototype: HTMLAmplifyCountryDialCodeElement;
        new (): HTMLAmplifyCountryDialCodeElement;
    };
    interface HTMLAmplifyEmailFieldElement extends Components.AmplifyEmailField, HTMLStencilElement {
    }
    var HTMLAmplifyEmailFieldElement: {
        prototype: HTMLAmplifyEmailFieldElement;
        new (): HTMLAmplifyEmailFieldElement;
    };
    interface HTMLAmplifyFacebookButtonElement extends Components.AmplifyFacebookButton, HTMLStencilElement {
    }
    var HTMLAmplifyFacebookButtonElement: {
        prototype: HTMLAmplifyFacebookButtonElement;
        new (): HTMLAmplifyFacebookButtonElement;
    };
    interface HTMLAmplifyFederatedButtonsElement extends Components.AmplifyFederatedButtons, HTMLStencilElement {
    }
    var HTMLAmplifyFederatedButtonsElement: {
        prototype: HTMLAmplifyFederatedButtonsElement;
        new (): HTMLAmplifyFederatedButtonsElement;
    };
    interface HTMLAmplifyFederatedSignInElement extends Components.AmplifyFederatedSignIn, HTMLStencilElement {
    }
    var HTMLAmplifyFederatedSignInElement: {
        prototype: HTMLAmplifyFederatedSignInElement;
        new (): HTMLAmplifyFederatedSignInElement;
    };
    interface HTMLAmplifyForgotPasswordElement extends Components.AmplifyForgotPassword, HTMLStencilElement {
    }
    var HTMLAmplifyForgotPasswordElement: {
        prototype: HTMLAmplifyForgotPasswordElement;
        new (): HTMLAmplifyForgotPasswordElement;
    };
    interface HTMLAmplifyFormFieldElement extends Components.AmplifyFormField, HTMLStencilElement {
    }
    var HTMLAmplifyFormFieldElement: {
        prototype: HTMLAmplifyFormFieldElement;
        new (): HTMLAmplifyFormFieldElement;
    };
    interface HTMLAmplifyFormSectionElement extends Components.AmplifyFormSection, HTMLStencilElement {
    }
    var HTMLAmplifyFormSectionElement: {
        prototype: HTMLAmplifyFormSectionElement;
        new (): HTMLAmplifyFormSectionElement;
    };
    interface HTMLAmplifyGoogleButtonElement extends Components.AmplifyGoogleButton, HTMLStencilElement {
    }
    var HTMLAmplifyGoogleButtonElement: {
        prototype: HTMLAmplifyGoogleButtonElement;
        new (): HTMLAmplifyGoogleButtonElement;
    };
    interface HTMLAmplifyGreetingsElement extends Components.AmplifyGreetings, HTMLStencilElement {
    }
    var HTMLAmplifyGreetingsElement: {
        prototype: HTMLAmplifyGreetingsElement;
        new (): HTMLAmplifyGreetingsElement;
    };
    interface HTMLAmplifyHintElement extends Components.AmplifyHint, HTMLStencilElement {
    }
    var HTMLAmplifyHintElement: {
        prototype: HTMLAmplifyHintElement;
        new (): HTMLAmplifyHintElement;
    };
    interface HTMLAmplifyIconElement extends Components.AmplifyIcon, HTMLStencilElement {
    }
    var HTMLAmplifyIconElement: {
        prototype: HTMLAmplifyIconElement;
        new (): HTMLAmplifyIconElement;
    };
    interface HTMLAmplifyIconButtonElement extends Components.AmplifyIconButton, HTMLStencilElement {
    }
    var HTMLAmplifyIconButtonElement: {
        prototype: HTMLAmplifyIconButtonElement;
        new (): HTMLAmplifyIconButtonElement;
    };
    interface HTMLAmplifyInputElement extends Components.AmplifyInput, HTMLStencilElement {
    }
    var HTMLAmplifyInputElement: {
        prototype: HTMLAmplifyInputElement;
        new (): HTMLAmplifyInputElement;
    };
    interface HTMLAmplifyLabelElement extends Components.AmplifyLabel, HTMLStencilElement {
    }
    var HTMLAmplifyLabelElement: {
        prototype: HTMLAmplifyLabelElement;
        new (): HTMLAmplifyLabelElement;
    };
    interface HTMLAmplifyLinkElement extends Components.AmplifyLink, HTMLStencilElement {
    }
    var HTMLAmplifyLinkElement: {
        prototype: HTMLAmplifyLinkElement;
        new (): HTMLAmplifyLinkElement;
    };
    interface HTMLAmplifyLoadingSpinnerElement extends Components.AmplifyLoadingSpinner, HTMLStencilElement {
    }
    var HTMLAmplifyLoadingSpinnerElement: {
        prototype: HTMLAmplifyLoadingSpinnerElement;
        new (): HTMLAmplifyLoadingSpinnerElement;
    };
    interface HTMLAmplifyNavElement extends Components.AmplifyNav, HTMLStencilElement {
    }
    var HTMLAmplifyNavElement: {
        prototype: HTMLAmplifyNavElement;
        new (): HTMLAmplifyNavElement;
    };
    interface HTMLAmplifyOauthButtonElement extends Components.AmplifyOauthButton, HTMLStencilElement {
    }
    var HTMLAmplifyOauthButtonElement: {
        prototype: HTMLAmplifyOauthButtonElement;
        new (): HTMLAmplifyOauthButtonElement;
    };
    interface HTMLAmplifyPasswordFieldElement extends Components.AmplifyPasswordField, HTMLStencilElement {
    }
    var HTMLAmplifyPasswordFieldElement: {
        prototype: HTMLAmplifyPasswordFieldElement;
        new (): HTMLAmplifyPasswordFieldElement;
    };
    interface HTMLAmplifyPhoneFieldElement extends Components.AmplifyPhoneField, HTMLStencilElement {
    }
    var HTMLAmplifyPhoneFieldElement: {
        prototype: HTMLAmplifyPhoneFieldElement;
        new (): HTMLAmplifyPhoneFieldElement;
    };
    interface HTMLAmplifyPhotoPickerElement extends Components.AmplifyPhotoPicker, HTMLStencilElement {
    }
    var HTMLAmplifyPhotoPickerElement: {
        prototype: HTMLAmplifyPhotoPickerElement;
        new (): HTMLAmplifyPhotoPickerElement;
    };
    interface HTMLAmplifyPickerElement extends Components.AmplifyPicker, HTMLStencilElement {
    }
    var HTMLAmplifyPickerElement: {
        prototype: HTMLAmplifyPickerElement;
        new (): HTMLAmplifyPickerElement;
    };
    interface HTMLAmplifyRadioButtonElement extends Components.AmplifyRadioButton, HTMLStencilElement {
    }
    var HTMLAmplifyRadioButtonElement: {
        prototype: HTMLAmplifyRadioButtonElement;
        new (): HTMLAmplifyRadioButtonElement;
    };
    interface HTMLAmplifyRequireNewPasswordElement extends Components.AmplifyRequireNewPassword, HTMLStencilElement {
    }
    var HTMLAmplifyRequireNewPasswordElement: {
        prototype: HTMLAmplifyRequireNewPasswordElement;
        new (): HTMLAmplifyRequireNewPasswordElement;
    };
    interface HTMLAmplifyS3AlbumElement extends Components.AmplifyS3Album, HTMLStencilElement {
    }
    var HTMLAmplifyS3AlbumElement: {
        prototype: HTMLAmplifyS3AlbumElement;
        new (): HTMLAmplifyS3AlbumElement;
    };
    interface HTMLAmplifyS3ImageElement extends Components.AmplifyS3Image, HTMLStencilElement {
    }
    var HTMLAmplifyS3ImageElement: {
        prototype: HTMLAmplifyS3ImageElement;
        new (): HTMLAmplifyS3ImageElement;
    };
    interface HTMLAmplifyS3ImagePickerElement extends Components.AmplifyS3ImagePicker, HTMLStencilElement {
    }
    var HTMLAmplifyS3ImagePickerElement: {
        prototype: HTMLAmplifyS3ImagePickerElement;
        new (): HTMLAmplifyS3ImagePickerElement;
    };
    interface HTMLAmplifyS3TextElement extends Components.AmplifyS3Text, HTMLStencilElement {
    }
    var HTMLAmplifyS3TextElement: {
        prototype: HTMLAmplifyS3TextElement;
        new (): HTMLAmplifyS3TextElement;
    };
    interface HTMLAmplifyS3TextPickerElement extends Components.AmplifyS3TextPicker, HTMLStencilElement {
    }
    var HTMLAmplifyS3TextPickerElement: {
        prototype: HTMLAmplifyS3TextPickerElement;
        new (): HTMLAmplifyS3TextPickerElement;
    };
    interface HTMLAmplifySectionElement extends Components.AmplifySection, HTMLStencilElement {
    }
    var HTMLAmplifySectionElement: {
        prototype: HTMLAmplifySectionElement;
        new (): HTMLAmplifySectionElement;
    };
    interface HTMLAmplifySelectElement extends Components.AmplifySelect, HTMLStencilElement {
    }
    var HTMLAmplifySelectElement: {
        prototype: HTMLAmplifySelectElement;
        new (): HTMLAmplifySelectElement;
    };
    interface HTMLAmplifySelectMfaTypeElement extends Components.AmplifySelectMfaType, HTMLStencilElement {
    }
    var HTMLAmplifySelectMfaTypeElement: {
        prototype: HTMLAmplifySelectMfaTypeElement;
        new (): HTMLAmplifySelectMfaTypeElement;
    };
    interface HTMLAmplifySignInElement extends Components.AmplifySignIn, HTMLStencilElement {
    }
    var HTMLAmplifySignInElement: {
        prototype: HTMLAmplifySignInElement;
        new (): HTMLAmplifySignInElement;
    };
    interface HTMLAmplifySignInButtonElement extends Components.AmplifySignInButton, HTMLStencilElement {
    }
    var HTMLAmplifySignInButtonElement: {
        prototype: HTMLAmplifySignInButtonElement;
        new (): HTMLAmplifySignInButtonElement;
    };
    interface HTMLAmplifySignOutElement extends Components.AmplifySignOut, HTMLStencilElement {
    }
    var HTMLAmplifySignOutElement: {
        prototype: HTMLAmplifySignOutElement;
        new (): HTMLAmplifySignOutElement;
    };
    interface HTMLAmplifySignUpElement extends Components.AmplifySignUp, HTMLStencilElement {
    }
    var HTMLAmplifySignUpElement: {
        prototype: HTMLAmplifySignUpElement;
        new (): HTMLAmplifySignUpElement;
    };
    interface HTMLAmplifyStrikeElement extends Components.AmplifyStrike, HTMLStencilElement {
    }
    var HTMLAmplifyStrikeElement: {
        prototype: HTMLAmplifyStrikeElement;
        new (): HTMLAmplifyStrikeElement;
    };
    interface HTMLAmplifyToastElement extends Components.AmplifyToast, HTMLStencilElement {
    }
    var HTMLAmplifyToastElement: {
        prototype: HTMLAmplifyToastElement;
        new (): HTMLAmplifyToastElement;
    };
    interface HTMLAmplifyTooltipElement extends Components.AmplifyTooltip, HTMLStencilElement {
    }
    var HTMLAmplifyTooltipElement: {
        prototype: HTMLAmplifyTooltipElement;
        new (): HTMLAmplifyTooltipElement;
    };
    interface HTMLAmplifyTotpSetupElement extends Components.AmplifyTotpSetup, HTMLStencilElement {
    }
    var HTMLAmplifyTotpSetupElement: {
        prototype: HTMLAmplifyTotpSetupElement;
        new (): HTMLAmplifyTotpSetupElement;
    };
    interface HTMLAmplifyUsernameFieldElement extends Components.AmplifyUsernameField, HTMLStencilElement {
    }
    var HTMLAmplifyUsernameFieldElement: {
        prototype: HTMLAmplifyUsernameFieldElement;
        new (): HTMLAmplifyUsernameFieldElement;
    };
    interface HTMLAmplifyVerifyContactElement extends Components.AmplifyVerifyContact, HTMLStencilElement {
    }
    var HTMLAmplifyVerifyContactElement: {
        prototype: HTMLAmplifyVerifyContactElement;
        new (): HTMLAmplifyVerifyContactElement;
    };
    interface HTMLElementTagNameMap {
        "amplify-amazon-button": HTMLAmplifyAmazonButtonElement;
        "amplify-auth-container": HTMLAmplifyAuthContainerElement;
        "amplify-auth-fields": HTMLAmplifyAuthFieldsElement;
        "amplify-auth0-button": HTMLAmplifyAuth0ButtonElement;
        "amplify-authenticator": HTMLAmplifyAuthenticatorElement;
        "amplify-button": HTMLAmplifyButtonElement;
        "amplify-chatbot": HTMLAmplifyChatbotElement;
        "amplify-checkbox": HTMLAmplifyCheckboxElement;
        "amplify-code-field": HTMLAmplifyCodeFieldElement;
        "amplify-confirm-sign-in": HTMLAmplifyConfirmSignInElement;
        "amplify-confirm-sign-up": HTMLAmplifyConfirmSignUpElement;
        "amplify-container": HTMLAmplifyContainerElement;
        "amplify-country-dial-code": HTMLAmplifyCountryDialCodeElement;
        "amplify-email-field": HTMLAmplifyEmailFieldElement;
        "amplify-facebook-button": HTMLAmplifyFacebookButtonElement;
        "amplify-federated-buttons": HTMLAmplifyFederatedButtonsElement;
        "amplify-federated-sign-in": HTMLAmplifyFederatedSignInElement;
        "amplify-forgot-password": HTMLAmplifyForgotPasswordElement;
        "amplify-form-field": HTMLAmplifyFormFieldElement;
        "amplify-form-section": HTMLAmplifyFormSectionElement;
        "amplify-google-button": HTMLAmplifyGoogleButtonElement;
        "amplify-greetings": HTMLAmplifyGreetingsElement;
        "amplify-hint": HTMLAmplifyHintElement;
        "amplify-icon": HTMLAmplifyIconElement;
        "amplify-icon-button": HTMLAmplifyIconButtonElement;
        "amplify-input": HTMLAmplifyInputElement;
        "amplify-label": HTMLAmplifyLabelElement;
        "amplify-link": HTMLAmplifyLinkElement;
        "amplify-loading-spinner": HTMLAmplifyLoadingSpinnerElement;
        "amplify-nav": HTMLAmplifyNavElement;
        "amplify-oauth-button": HTMLAmplifyOauthButtonElement;
        "amplify-password-field": HTMLAmplifyPasswordFieldElement;
        "amplify-phone-field": HTMLAmplifyPhoneFieldElement;
        "amplify-photo-picker": HTMLAmplifyPhotoPickerElement;
        "amplify-picker": HTMLAmplifyPickerElement;
        "amplify-radio-button": HTMLAmplifyRadioButtonElement;
        "amplify-require-new-password": HTMLAmplifyRequireNewPasswordElement;
        "amplify-s3-album": HTMLAmplifyS3AlbumElement;
        "amplify-s3-image": HTMLAmplifyS3ImageElement;
        "amplify-s3-image-picker": HTMLAmplifyS3ImagePickerElement;
        "amplify-s3-text": HTMLAmplifyS3TextElement;
        "amplify-s3-text-picker": HTMLAmplifyS3TextPickerElement;
        "amplify-section": HTMLAmplifySectionElement;
        "amplify-select": HTMLAmplifySelectElement;
        "amplify-select-mfa-type": HTMLAmplifySelectMfaTypeElement;
        "amplify-sign-in": HTMLAmplifySignInElement;
        "amplify-sign-in-button": HTMLAmplifySignInButtonElement;
        "amplify-sign-out": HTMLAmplifySignOutElement;
        "amplify-sign-up": HTMLAmplifySignUpElement;
        "amplify-strike": HTMLAmplifyStrikeElement;
        "amplify-toast": HTMLAmplifyToastElement;
        "amplify-tooltip": HTMLAmplifyTooltipElement;
        "amplify-totp-setup": HTMLAmplifyTotpSetupElement;
        "amplify-username-field": HTMLAmplifyUsernameFieldElement;
        "amplify-verify-contact": HTMLAmplifyVerifyContactElement;
    }
}
declare namespace LocalJSX {
    interface AmplifyAmazonButton {
        /**
          * App-specific client ID from Google
         */
        "clientId"?: FederatedConfig['amazonClientId'];
        /**
          * Auth state change handler for this component e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange"?: AuthStateHandler;
    }
    interface AmplifyAuthContainer {
    }
    interface AmplifyAuthFields {
        /**
          * Form fields allows you to utilize our pre-built components such as username field, code field, password field, email field, etc. by passing an array of strings that you would like the order of the form to be in. If you need more customization, such as changing text for a label or adjust a placeholder, you can follow the structure below in order to do just that. ``` [   {     type: string,     label: string,     placeholder: string,     hint: string | Functional Component | null,     required: boolean   } ] ```
         */
        "formFields"?: FormFieldTypes | string[];
    }
    interface AmplifyAuth0Button {
        /**
          * See: https://auth0.com/docs/libraries/auth0js/v9#available-parameters
         */
        "config"?: FederatedConfig['auth0Config'];
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange"?: AuthStateHandler;
    }
    interface AmplifyAuthenticator {
        /**
          * Federated credentials & configuration.
         */
        "federated"?: FederatedConfig;
        /**
          * Callback for Authenticator state machine changes
         */
        "handleAuthStateChange"?: AuthStateHandler;
        /**
          * Hide amplify-toast for auth errors
         */
        "hideToast"?: boolean;
        /**
          * Initial starting state of the Authenticator component. E.g. If `signup` is passed the default component is set to AmplifySignUp
         */
        "initialAuthState"?: | AuthState.SignIn
		| AuthState.SignUp
		| AuthState.ForgotPassword;
        /**
          * Username Alias is used to setup authentication with `username`, `email` or `phone_number`
         */
        "usernameAlias"?: UsernameAliasStrings;
    }
    interface AmplifyButton {
        /**
          * Disabled state of the button
         */
        "disabled"?: boolean;
        /**
          * (Optional) Callback called when a user clicks on the button
         */
        "handleButtonClick"?: (evt: Event) => void;
        /**
          * Name of icon to be placed inside the button
         */
        "icon"?: IconNameType;
        /**
          * Type of the button: 'button', 'submit' or 'reset'
         */
        "type"?: ButtonTypes;
        /**
          * Variant of a button: 'button' | 'anchor | 'icon'
         */
        "variant"?: ButtonVariant;
    }
    interface AmplifyChatbot {
        /**
          * Name of the bot
         */
        "botName"?: string;
        /**
          * Text placed in the top header
         */
        "botTitle"?: string;
        /**
          * Clear messages when conversation finishes
         */
        "clearOnComplete"?: boolean;
        /**
          * Continue listening to users after they send the message
         */
        "conversationModeOn"?: boolean;
        /**
          * Event emitted when conversation is completed
         */
        "onChatCompleted"?: (event: CustomEvent<ChatResult>) => void;
        /**
          * Noise threshold between -1 and 1. Anything below is considered a silence.
         */
        "silenceThreshold"?: number;
        /**
          * Amount of silence (in ms) to wait for
         */
        "silenceTime"?: number;
        /**
          * Whether text chat is enabled
         */
        "textEnabled"?: boolean;
        /**
          * Whether voice chat is enabled
         */
        "voiceEnabled"?: boolean;
        /**
          * Greeting message displayed to users
         */
        "welcomeMessage"?: string;
    }
    interface AmplifyCheckbox {
        /**
          * If `true`, the checkbox is selected.
         */
        "checked"?: boolean;
        /**
          * If `true`, the checkbox is disabled
         */
        "disabled"?: boolean;
        /**
          * Field ID used for the 'htmlFor' in the label
         */
        "fieldId"?: string;
        /**
          * Label for the checkbox
         */
        "label"?: string;
        /**
          * Name of the checkbox
         */
        "name"?: string;
        /**
          * Value of the checkbox
         */
        "value"?: string;
    }
    interface AmplifyCodeField {
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * Based on the type of field e.g. sign in, sign up, forgot password, etc.
         */
        "fieldId"?: string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Used as the hint in case you forgot your confirmation code, etc.
         */
        "hint"?: string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Used for the code label
         */
        "label"?: string;
        /**
          * Used for the placeholder label
         */
        "placeholder"?: string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required"?: boolean;
        /**
          * The value of the content inside of the input field
         */
        "value"?: string;
    }
    interface AmplifyConfirmSignIn {
        /**
          * Form fields allows you to utilize our pre-built components such as username field, code field, password field, email field, etc. by passing an array of strings that you would like the order of the form to be in. If you need more customization, such as changing text for a label or adjust a placeholder, you can follow the structure below in order to do just that. ``` [   {     type: string,     label: string,     placeholder: string,     hint: string | Functional Component | null,     required: boolean   } ] ```
         */
        "formFields"?: FormFieldTypes | string[];
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange"?: AuthStateHandler;
        /**
          * Fires when confirm sign in form is submitted
         */
        "handleSubmit"?: (event: Event) => void;
        /**
          * Used for header text in confirm sign in component
         */
        "headerText"?: string;
        /**
          * Used for the submit button text in confirm sign in component
         */
        "submitButtonText"?: string;
        /**
          * Cognito user signing in
         */
        "user"?: CognitoUserInterface;
    }
    interface AmplifyConfirmSignUp {
        /**
          * Form fields allows you to utilize our pre-built components such as username field, code field, password field, email field, etc. by passing an array of strings that you would like the order of the form to be in. If you need more customization, such as changing text for a label or adjust a placeholder, you can follow the structure below in order to do just that. ``` [   {     type: string,     label: string,     placeholder: string,     hint: string | Functional Component | null,     required: boolean   } ] ```
         */
        "formFields"?: FormFieldTypes | string[];
        /**
          * Auth state change handler for this components e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange"?: AuthStateHandler;
        /**
          * Fires when sign up form is submitted
         */
        "handleSubmit"?: (submitEvent: Event) => void;
        /**
          * Used for header text in confirm sign up component
         */
        "headerText"?: string;
        /**
          * Used for the submit button text in confirm sign up component
         */
        "submitButtonText"?: string;
        /**
          * Used for the username to be passed to resend code
         */
        "user"?: CognitoUserInterface;
        /**
          * Username Alias is used to setup authentication with `username`, `email` or `phone_number`
         */
        "usernameAlias"?: UsernameAliasStrings;
    }
    interface AmplifyContainer {
    }
    interface AmplifyCountryDialCode {
        /**
          * Default selected dial code
         */
        "dialCode"?: string | number;
        /**
          * The ID of the field.  Should match with its corresponding input's ID.
         */
        "fieldId"?: string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * The options of the country dial code select input.
         */
        "options"?: CountryCodeDialOptions;
    }
    interface AmplifyEmailField {
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * Based on the type of field e.g. sign in, sign up, forgot password, etc.
         */
        "fieldId"?: string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Used for the hint text that displays underneath the input field
         */
        "hint"?: string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Used for the EMAIL label
         */
        "label"?: string;
        /**
          * Used for the placeholder label
         */
        "placeholder"?: string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required"?: boolean;
        /**
          * The value of the content inside of the input field
         */
        "value"?: string;
    }
    interface AmplifyFacebookButton {
        /**
          * App-specific client ID from Facebook
         */
        "appId"?: FederatedConfig['facebookAppId'];
        /**
          * Auth state change handler for this component e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange"?: AuthStateHandler;
    }
    interface AmplifyFederatedButtons {
        /**
          * The current authentication state.
         */
        "authState"?: AuthState;
        /**
          * Federated credentials & configuration.
         */
        "federated"?: FederatedConfig;
        /**
          * Auth state change handler for this component e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange"?: AuthStateHandler;
    }
    interface AmplifyFederatedSignIn {
        /**
          * The current authentication state.
         */
        "authState"?: AuthState;
        /**
          * Federated credentials & configuration.
         */
        "federated"?: any;
    }
    interface AmplifyForgotPassword {
        /**
          * The form fields displayed inside of the forgot password form
         */
        "formFields"?: FormFieldTypes | string[];
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange"?: AuthStateHandler;
        /**
          * The function called when making a request to reset password
         */
        "handleSend"?: (event: Event) => void;
        /**
          * The function called when submitting a new password
         */
        "handleSubmit"?: (event: Event) => void;
        /**
          * The header text of the forgot password section
         */
        "headerText"?: string;
        /**
          * The text displayed inside of the send code button for the form
         */
        "sendButtonText"?: string;
        /**
          * The text displayed inside of the submit button for the form
         */
        "submitButtonText"?: string;
        /**
          * Username Alias is used to setup authentication with `username`, `email` or `phone_number`
         */
        "usernameAlias"?: UsernameAliasStrings;
    }
    interface AmplifyFormField {
        /**
          * The text of the description.  Goes between the label and the input.
         */
        "description"?: string | null;
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * The ID of the field. Should match with its corresponding input's ID.
         */
        "fieldId"?: string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * The text of a hint to the user as to how to fill out the input. Goes just below the input.
         */
        "hint"?: string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * The text of the label. Goes above the input. Ex: 'First name'
         */
        "label"?: string | null;
        /**
          * (Optional) String value for the name of the input.
         */
        "name"?: string;
        /**
          * (Optional) The placeholder for the input element.  Using hints is recommended, but placeholders can also be useful to convey information to users.
         */
        "placeholder"?: string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required"?: boolean;
        /**
          * The input type.  Can be any HTML input type.
         */
        "type"?: TextFieldTypes;
        /**
          * The value of the content inside of the input field
         */
        "value"?: string;
    }
    interface AmplifyFormSection {
        /**
          * (Required) Function called upon submission of form
         */
        "handleSubmit"?: (event: Event) => void;
        /**
          * Used for form section header
         */
        "headerText"?: string;
        /**
          * Loading state for the form
         */
        "loading"?: boolean;
        /**
          * Secondary footer component or text
         */
        "secondaryFooterContent"?: string | FunctionalComponent | null;
        /**
          * (Optional) Used as a the default value within the default footer slot
         */
        "submitButtonText"?: string;
        /**
          * String prefix for the data-test attributes in this component primarily used for testing purposes
         */
        "testDataPrefix"?: string;
    }
    interface AmplifyGoogleButton {
        /**
          * App-specific client ID from Google
         */
        "clientId"?: FederatedConfig['googleClientId'];
        /**
          * Auth state change handler for this component e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange"?: AuthStateHandler;
    }
    interface AmplifyGreetings {
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange"?: AuthStateHandler;
        /**
          * Logo displayed inside of the header
         */
        "logo"?: FunctionalComponent | null;
        /**
          * Username displayed in the greetings
         */
        "username"?: string;
    }
    interface AmplifyHint {
    }
    interface AmplifyIcon {
        /**
          * (Required) Name of icon used to determine the icon rendered
         */
        "name"?: IconNameType;
    }
    interface AmplifyIconButton {
        /**
          * (Optional) Whether or not to show the tooltip automatically
         */
        "autoShowTooltip"?: boolean;
        /**
          * The name of the icon used inside of the button
         */
        "name"?: IconNameType;
        /**
          * (Optional) The tooltip that will show on hover of the button
         */
        "tooltip"?: string | null;
    }
    interface AmplifyInput {
        /**
          * The text of the description.  Goes just below the label.
         */
        "description"?: string | null;
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * The ID of the field.  Should match with its corresponding input's ID.
         */
        "fieldId"?: string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: InputEvent) => void;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * (Optional) String value for the name of the input.
         */
        "name"?: string;
        /**
          * (Optional) The placeholder for the input element.  Using hints is recommended, but placeholders can also be useful to convey information to users.
         */
        "placeholder"?: string;
        /**
          * Whether the input is a required field
         */
        "required"?: boolean;
        /**
          * The input type.  Can be any HTML input type.
         */
        "type"?: TextFieldTypes;
        /**
          * The value of the content inside of the input field
         */
        "value"?: string;
    }
    interface AmplifyLabel {
        /**
          * Reflects the value of the for content property of html element
         */
        "htmlFor"?: string;
    }
    interface AmplifyLink {
        /**
          * The link role is used to identify an element that creates a hyperlink to a resource that is in the application or external
         */
        "role"?: string;
    }
    interface AmplifyLoadingSpinner {
    }
    interface AmplifyNav {
    }
    interface AmplifyOauthButton {
        /**
          * Federated credentials & configuration.
         */
        "config"?: FederatedConfig['oauthConfig'];
    }
    interface AmplifyPasswordField {
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * Based on the type of field e.g. sign in, sign up, forgot password, etc.
         */
        "fieldId"?: string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Used as the hint in case you forgot your password, etc.
         */
        "hint"?: string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Used for the password label
         */
        "label"?: string;
        /**
          * Used for the placeholder label
         */
        "placeholder"?: string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required"?: boolean;
        /**
          * The value of the content inside of the input field
         */
        "value"?: string;
    }
    interface AmplifyPhoneField {
        /**
          * Default dial code in the phone field
         */
        "dialCode"?: string | number;
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * Based on the type of field e.g. sign in, sign up, forgot password, etc.
         */
        "fieldId"?: string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Used as the hint in case you forgot your confirmation code, etc.
         */
        "hint"?: string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Used for the Phone label
         */
        "label"?: string;
        /**
          * Used for the placeholder label
         */
        "placeholder"?: string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required"?: boolean;
        /**
          * The value of the content inside of the input field
         */
        "value"?: string;
    }
    interface AmplifyPhotoPicker {
        /**
          * Picker button text as string
         */
        "buttonText"?: string;
        /**
          * Function that handles file pick onClick
         */
        "handleClick"?: (file: File) => void;
        /**
          * Header Hint value in string
         */
        "headerHint"?: string;
        /**
          * Title string value
         */
        "headerTitle"?: string;
        /**
          * Placeholder hint that goes under the placeholder image
         */
        "placeholderHint"?: string;
        /**
          * Source of the image to be previewed
         */
        "previewSrc"?: string | object;
    }
    interface AmplifyPicker {
        /**
          * File input accept value
         */
        "acceptValue"?: string;
        /**
          * File input onChange handler
         */
        "inputHandler"?: (e: Event) => void;
        /**
          * Picker button text
         */
        "pickerText"?: string;
    }
    interface AmplifyRadioButton {
        /**
          * If `true`, the radio button is selected.
         */
        "checked"?: boolean;
        /**
          * If `true`, the checkbox is disabled
         */
        "disabled"?: boolean;
        /**
          * Field ID used for the 'for' in the label
         */
        "fieldId"?: string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Label for the radio button
         */
        "label"?: string;
        /**
          * (Optional) Name of radio button
         */
        "name"?: string;
        /**
          * (Optional) The placeholder for the input element.  Using hints is recommended, but placeholders can also be useful to convey information to users.
         */
        "placeholder"?: string;
        /**
          * (Optional) Value of radio button
         */
        "value"?: string;
    }
    interface AmplifyRequireNewPassword {
        /**
          * The form fields displayed inside of the forgot password form
         */
        "formFields"?: FormFieldTypes;
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange"?: AuthStateHandler;
        /**
          * The function called when submitting a new password
         */
        "handleSubmit"?: (event: Event) => void;
        /**
          * The header text of the forgot password section
         */
        "headerText"?: string;
        /**
          * The text displayed inside of the submit button for the form
         */
        "submitButtonText"?: string;
        /**
          * Used for the username to be passed to resend code
         */
        "user"?: CognitoUserInterface;
    }
    interface AmplifyS3Album {
        /**
          * The content type header used when uploading to S3
         */
        "contentType"?: string;
        /**
          * Callback used to generate custom key value
         */
        "fileToKey"?: (data: object) => string | string;
        /**
          * Filter to be applied on album list
         */
        "filter"?: (list: StorageObject[]) => StorageObject[];
        /**
          * Function executed when error occurs for the s3-image
         */
        "handleOnError"?: (event: Event) => void;
        /**
          * Function executed when s3-image loads
         */
        "handleOnLoad"?: (event: Event) => void;
        /**
          * Cognito identity id of the another user's image list
         */
        "identityId"?: string;
        /**
          * The access level of the files
         */
        "level"?: AccessLevel;
        /**
          * String representing directory location of image files to be listed
         */
        "path"?: string;
        /**
          * Boolean to enable or disable picker
         */
        "picker"?: boolean;
        /**
          * Picker button text
         */
        "pickerText"?: string;
        /**
          * Sort to be applied on album list
         */
        "sort"?: (list: StorageObject[]) => StorageObject[];
        /**
          * Whether or not to use track the get/put of the listing of images
         */
        "track"?: boolean;
    }
    interface AmplifyS3Image {
        /**
          * String representing the alternate image text
         */
        "alt"?: string;
        /**
          * Image body content to be uploaded
         */
        "body"?: object;
        /**
          * The content type header used when uploading to S3
         */
        "contentType"?: string;
        /**
          * Function executed when error occurs for the image
         */
        "handleOnError"?: (event: Event) => void;
        /**
          * Function executed when image loads
         */
        "handleOnLoad"?: (event: Event) => void;
        /**
          * Cognito identity id of the another user's image
         */
        "identityId"?: string;
        /**
          * The key of the image object in S3
         */
        "imgKey"?: string;
        /**
          * Attributes to be placed on the img element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/img#attributes
         */
        "imgProps"?: Record<PropertyKey, any>;
        /**
          * The access level of the image
         */
        "level"?: AccessLevel;
        /**
          * String representing directory location to image file
         */
        "path"?: string;
        /**
          * Whether or not to use track on get/put of the image
         */
        "track"?: boolean;
    }
    interface AmplifyS3ImagePicker {
        /**
          * Upload Button Text as string
         */
        "buttonText"?: string;
        /**
          * The content type header used when uploading to S3
         */
        "contentType"?: string;
        /**
          * Callback used to generate custom key value
         */
        "fileToKey"?: (data: object) => string | string;
        /**
          * Header Hint value in string
         */
        "headerHint"?: string;
        /**
          * Title string value
         */
        "headerTitle"?: string;
        /**
          * Cognito identity id of the another user's image
         */
        "identityId"?: string;
        /**
          * The access level of the image
         */
        "level"?: AccessLevel;
        /**
          * String representing directory location to image file
         */
        "path"?: string;
        /**
          * Placeholder hint that goes under the placeholder image
         */
        "placeholderHint"?: string;
        /**
          * Whether or not to use track the get/put of the image
         */
        "track"?: boolean;
    }
    interface AmplifyS3Text {
        /**
          * Text body content to be uploaded
         */
        "body"?: object;
        /**
          * The content type header used when uploading to S3
         */
        "contentType"?: string;
        /**
          * Fallback content
         */
        "fallbackText"?: string;
        /**
          * Cognito identity id of the another user's text file
         */
        "identityId"?: string;
        /**
          * The access level of the text file
         */
        "level"?: AccessLevel;
        /**
          * String representing directory location to text file
         */
        "path"?: string;
        /**
          * The key of the text object in S3
         */
        "textKey"?: string;
        /**
          * Whether or not to use track the get/put of the text file
         */
        "track"?: boolean;
    }
    interface AmplifyS3TextPicker {
        /**
          * The content type header used when uploading to S3
         */
        "contentType"?: string;
        /**
          * Fallback content for aplify-s3-text
         */
        "fallbackText"?: string;
        /**
          * Callback used to generate custom key value
         */
        "fileToKey"?: (data: object) => string | string;
        /**
          * Cognito identity id of the another user's text file
         */
        "identityId"?: string;
        /**
          * The access level of the text file
         */
        "level"?: AccessLevel;
        /**
          * String representing directory location to text file
         */
        "path"?: string;
        /**
          * Whether or not to use track the get/put of the text file
         */
        "track"?: boolean;
    }
    interface AmplifySection {
        /**
          * Equivalent to html section role
         */
        "role"?: string;
    }
    interface AmplifySelect {
        /**
          * Used for id field
         */
        "fieldId"?: string;
        /**
          * The callback, called when the select is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * The options of the select input. Must be an Array of Objects with an Object shape of {label: string, value: string|number}
         */
        "options"?: | SelectOptionsString
		| SelectOptionsNumber;
        /**
          * Default selected option
         */
        "selected"?: string | number;
    }
    interface AmplifySelectMfaType {
        /**
          * Types of MFA options
         */
        "MFATypes"?: MFATypesInterface;
        /**
          * Current authenticated user in order to sign requests properly for TOTP
         */
        "authData"?: CognitoUserInterface;
        /**
          * Fires when Verify is clicked
         */
        "handleSubmit"?: (event: Event) => void;
    }
    interface AmplifySignIn {
        /**
          * Federated credentials & configuration.
         */
        "federated"?: FederatedConfig;
        /**
          * Form fields allows you to utilize our pre-built components such as username field, code field, password field, email field, etc. by passing an array of strings that you would like the order of the form to be in. If you need more customization, such as changing text for a label or adjust a placeholder, you can follow the structure below in order to do just that. ``` [   {     type: string,     label: string,     placeholder: string,     hint: string | Functional Component | null,     required: boolean   } ] ```
         */
        "formFields"?: FormFieldTypes | string[];
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange"?: AuthStateHandler;
        /**
          * Fires when sign in form is submitted
         */
        "handleSubmit"?: (event: Event) => void;
        /**
          * Used for header text in sign in component
         */
        "headerText"?: string;
        /**
          * Hides the sign up link
         */
        "hideSignUp"?: boolean;
        /**
          * Used for the submit button text in sign in component
         */
        "submitButtonText"?: string;
        /**
          * Username Alias is used to setup authentication with `username`, `email` or `phone_number`
         */
        "usernameAlias"?: UsernameAliasStrings;
    }
    interface AmplifySignInButton {
        /**
          * Specifies the federation provider.
         */
        "provider"?: 'amazon' | 'auth0' | 'facebook' | 'google' | 'oauth';
    }
    interface AmplifySignOut {
        /**
          * Text inside of the Sign Out button
         */
        "buttonText"?: string;
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange"?: AuthStateHandler;
    }
    interface AmplifySignUp {
        /**
          * Form fields allows you to utilize our pre-built components such as username field, code field, password field, email field, etc. by passing an array of strings that you would like the order of the form to be in. If you need more customization, such as changing text for a label or adjust a placeholder, you can follow the structure below in order to do just that. ``` [   {     type: string,     label: string,     placeholder: string,     hint: string | Functional Component | null,     required: boolean   } ] ```
         */
        "formFields"?: FormFieldTypes | string[];
        /**
          * Auth state change handler for this component e.g. SignIn -> 'Create Account' link -> SignUp
         */
        "handleAuthStateChange"?: AuthStateHandler;
        /**
          * Override for handling the Auth.SignUp API call
         */
        "handleSignUp"?: (
		params: SignUpParams
	) => Promise<ISignUpResult>;
        /**
          * Fires when sign up form is submitted
         */
        "handleSubmit"?: (event: Event) => void;
        /**
          * Used for the submit button text in sign up component
         */
        "haveAccountText"?: string;
        /**
          * Used for header text in sign up component
         */
        "headerText"?: string;
        /**
          * Text used for the sign in hyperlink
         */
        "signInText"?: string;
        /**
          * Used for the submit button text in sign up component
         */
        "submitButtonText"?: string;
        /**
          * Username Alias is used to setup authentication with `username`, `email` or `phone_number`
         */
        "usernameAlias"?: UsernameAliasStrings;
        /**
          * Engages when invalid actions occur, such as missing field, etc.
         */
        "validationErrors"?: string;
    }
    interface AmplifyStrike {
    }
    interface AmplifyToast {
        /**
          * Used in order to add a dismissable `x` for the Toast component
         */
        "handleClose"?: () => void;
        /**
          * Message to be displayed inside the toast
         */
        "message"?: string;
    }
    interface AmplifyTooltip {
        /**
          * (Optional) Whether or not the tooltip should be automatically shown, i.e. not disappear when not hovered
         */
        "shouldAutoShow"?: boolean;
        /**
          * (Required) The text in the tooltip
         */
        "text"?: string;
    }
    interface AmplifyTotpSetup {
        /**
          * Auth state change handler for this component
         */
        "handleAuthStateChange"?: AuthStateHandler;
        /**
          * This is run after totp setup is complete. Useful if using this as standalone.
         */
        "handleComplete"?: (
		user: CognitoUserInterface
	) => void | Promise<void>;
        /**
          * Used for header text in totp setup component
         */
        "headerText"?: string;
        /**
          * Used for customizing the issuer string in the qr code image
         */
        "issuer"?: string;
        /**
          * Set this to true if this component is running outside the default `amplify-authenticator` usage
         */
        "standalone"?: boolean;
        /**
          * Used in order to configure TOTP for a user
         */
        "user"?: CognitoUserInterface;
    }
    interface AmplifyUsernameField {
        /**
          * Will disable the input if set to true
         */
        "disabled"?: boolean;
        /**
          * Based on the type of field e.g. sign in, sign up, forgot password, etc.
         */
        "fieldId"?: string;
        /**
          * The callback, called when the input is modified by the user.
         */
        "handleInputChange"?: (inputEvent: Event) => void;
        /**
          * Used for the hint text that displays underneath the input field
         */
        "hint"?: string | FunctionalComponent | null;
        /**
          * Attributes places on the input element: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes
         */
        "inputProps"?: object;
        /**
          * Used for the username label
         */
        "label"?: string;
        /**
          * Used for the placeholder label
         */
        "placeholder"?: string;
        /**
          * The required flag in order to make an input required prior to submitting a form
         */
        "required"?: boolean;
        /**
          * The value of the content inside of the input field
         */
        "value"?: string;
    }
    interface AmplifyVerifyContact {
        /**
          * Authentication state handler
         */
        "handleAuthStateChange"?: AuthStateHandler;
        /**
          * User with unverified contact information
         */
        "user"?: CognitoUserInterface;
    }
    interface IntrinsicElements {
        "amplify-amazon-button": AmplifyAmazonButton;
        "amplify-auth-container": AmplifyAuthContainer;
        "amplify-auth-fields": AmplifyAuthFields;
        "amplify-auth0-button": AmplifyAuth0Button;
        "amplify-authenticator": AmplifyAuthenticator;
        "amplify-button": AmplifyButton;
        "amplify-chatbot": AmplifyChatbot;
        "amplify-checkbox": AmplifyCheckbox;
        "amplify-code-field": AmplifyCodeField;
        "amplify-confirm-sign-in": AmplifyConfirmSignIn;
        "amplify-confirm-sign-up": AmplifyConfirmSignUp;
        "amplify-container": AmplifyContainer;
        "amplify-country-dial-code": AmplifyCountryDialCode;
        "amplify-email-field": AmplifyEmailField;
        "amplify-facebook-button": AmplifyFacebookButton;
        "amplify-federated-buttons": AmplifyFederatedButtons;
        "amplify-federated-sign-in": AmplifyFederatedSignIn;
        "amplify-forgot-password": AmplifyForgotPassword;
        "amplify-form-field": AmplifyFormField;
        "amplify-form-section": AmplifyFormSection;
        "amplify-google-button": AmplifyGoogleButton;
        "amplify-greetings": AmplifyGreetings;
        "amplify-hint": AmplifyHint;
        "amplify-icon": AmplifyIcon;
        "amplify-icon-button": AmplifyIconButton;
        "amplify-input": AmplifyInput;
        "amplify-label": AmplifyLabel;
        "amplify-link": AmplifyLink;
        "amplify-loading-spinner": AmplifyLoadingSpinner;
        "amplify-nav": AmplifyNav;
        "amplify-oauth-button": AmplifyOauthButton;
        "amplify-password-field": AmplifyPasswordField;
        "amplify-phone-field": AmplifyPhoneField;
        "amplify-photo-picker": AmplifyPhotoPicker;
        "amplify-picker": AmplifyPicker;
        "amplify-radio-button": AmplifyRadioButton;
        "amplify-require-new-password": AmplifyRequireNewPassword;
        "amplify-s3-album": AmplifyS3Album;
        "amplify-s3-image": AmplifyS3Image;
        "amplify-s3-image-picker": AmplifyS3ImagePicker;
        "amplify-s3-text": AmplifyS3Text;
        "amplify-s3-text-picker": AmplifyS3TextPicker;
        "amplify-section": AmplifySection;
        "amplify-select": AmplifySelect;
        "amplify-select-mfa-type": AmplifySelectMfaType;
        "amplify-sign-in": AmplifySignIn;
        "amplify-sign-in-button": AmplifySignInButton;
        "amplify-sign-out": AmplifySignOut;
        "amplify-sign-up": AmplifySignUp;
        "amplify-strike": AmplifyStrike;
        "amplify-toast": AmplifyToast;
        "amplify-tooltip": AmplifyTooltip;
        "amplify-totp-setup": AmplifyTotpSetup;
        "amplify-username-field": AmplifyUsernameField;
        "amplify-verify-contact": AmplifyVerifyContact;
    }
}
export { LocalJSX as JSX };
declare module "@stencil/core" {
    export namespace JSX {
        interface IntrinsicElements {
            "amplify-amazon-button": LocalJSX.AmplifyAmazonButton & JSXBase.HTMLAttributes<HTMLAmplifyAmazonButtonElement>;
            "amplify-auth-container": LocalJSX.AmplifyAuthContainer & JSXBase.HTMLAttributes<HTMLAmplifyAuthContainerElement>;
            "amplify-auth-fields": LocalJSX.AmplifyAuthFields & JSXBase.HTMLAttributes<HTMLAmplifyAuthFieldsElement>;
            "amplify-auth0-button": LocalJSX.AmplifyAuth0Button & JSXBase.HTMLAttributes<HTMLAmplifyAuth0ButtonElement>;
            "amplify-authenticator": LocalJSX.AmplifyAuthenticator & JSXBase.HTMLAttributes<HTMLAmplifyAuthenticatorElement>;
            "amplify-button": LocalJSX.AmplifyButton & JSXBase.HTMLAttributes<HTMLAmplifyButtonElement>;
            "amplify-chatbot": LocalJSX.AmplifyChatbot & JSXBase.HTMLAttributes<HTMLAmplifyChatbotElement>;
            "amplify-checkbox": LocalJSX.AmplifyCheckbox & JSXBase.HTMLAttributes<HTMLAmplifyCheckboxElement>;
            "amplify-code-field": LocalJSX.AmplifyCodeField & JSXBase.HTMLAttributes<HTMLAmplifyCodeFieldElement>;
            "amplify-confirm-sign-in": LocalJSX.AmplifyConfirmSignIn & JSXBase.HTMLAttributes<HTMLAmplifyConfirmSignInElement>;
            "amplify-confirm-sign-up": LocalJSX.AmplifyConfirmSignUp & JSXBase.HTMLAttributes<HTMLAmplifyConfirmSignUpElement>;
            "amplify-container": LocalJSX.AmplifyContainer & JSXBase.HTMLAttributes<HTMLAmplifyContainerElement>;
            "amplify-country-dial-code": LocalJSX.AmplifyCountryDialCode & JSXBase.HTMLAttributes<HTMLAmplifyCountryDialCodeElement>;
            "amplify-email-field": LocalJSX.AmplifyEmailField & JSXBase.HTMLAttributes<HTMLAmplifyEmailFieldElement>;
            "amplify-facebook-button": LocalJSX.AmplifyFacebookButton & JSXBase.HTMLAttributes<HTMLAmplifyFacebookButtonElement>;
            "amplify-federated-buttons": LocalJSX.AmplifyFederatedButtons & JSXBase.HTMLAttributes<HTMLAmplifyFederatedButtonsElement>;
            "amplify-federated-sign-in": LocalJSX.AmplifyFederatedSignIn & JSXBase.HTMLAttributes<HTMLAmplifyFederatedSignInElement>;
            "amplify-forgot-password": LocalJSX.AmplifyForgotPassword & JSXBase.HTMLAttributes<HTMLAmplifyForgotPasswordElement>;
            "amplify-form-field": LocalJSX.AmplifyFormField & JSXBase.HTMLAttributes<HTMLAmplifyFormFieldElement>;
            "amplify-form-section": LocalJSX.AmplifyFormSection & JSXBase.HTMLAttributes<HTMLAmplifyFormSectionElement>;
            "amplify-google-button": LocalJSX.AmplifyGoogleButton & JSXBase.HTMLAttributes<HTMLAmplifyGoogleButtonElement>;
            "amplify-greetings": LocalJSX.AmplifyGreetings & JSXBase.HTMLAttributes<HTMLAmplifyGreetingsElement>;
            "amplify-hint": LocalJSX.AmplifyHint & JSXBase.HTMLAttributes<HTMLAmplifyHintElement>;
            "amplify-icon": LocalJSX.AmplifyIcon & JSXBase.HTMLAttributes<HTMLAmplifyIconElement>;
            "amplify-icon-button": LocalJSX.AmplifyIconButton & JSXBase.HTMLAttributes<HTMLAmplifyIconButtonElement>;
            "amplify-input": LocalJSX.AmplifyInput & JSXBase.HTMLAttributes<HTMLAmplifyInputElement>;
            "amplify-label": LocalJSX.AmplifyLabel & JSXBase.HTMLAttributes<HTMLAmplifyLabelElement>;
            "amplify-link": LocalJSX.AmplifyLink & JSXBase.HTMLAttributes<HTMLAmplifyLinkElement>;
            "amplify-loading-spinner": LocalJSX.AmplifyLoadingSpinner & JSXBase.HTMLAttributes<HTMLAmplifyLoadingSpinnerElement>;
            "amplify-nav": LocalJSX.AmplifyNav & JSXBase.HTMLAttributes<HTMLAmplifyNavElement>;
            "amplify-oauth-button": LocalJSX.AmplifyOauthButton & JSXBase.HTMLAttributes<HTMLAmplifyOauthButtonElement>;
            "amplify-password-field": LocalJSX.AmplifyPasswordField & JSXBase.HTMLAttributes<HTMLAmplifyPasswordFieldElement>;
            "amplify-phone-field": LocalJSX.AmplifyPhoneField & JSXBase.HTMLAttributes<HTMLAmplifyPhoneFieldElement>;
            "amplify-photo-picker": LocalJSX.AmplifyPhotoPicker & JSXBase.HTMLAttributes<HTMLAmplifyPhotoPickerElement>;
            "amplify-picker": LocalJSX.AmplifyPicker & JSXBase.HTMLAttributes<HTMLAmplifyPickerElement>;
            "amplify-radio-button": LocalJSX.AmplifyRadioButton & JSXBase.HTMLAttributes<HTMLAmplifyRadioButtonElement>;
            "amplify-require-new-password": LocalJSX.AmplifyRequireNewPassword & JSXBase.HTMLAttributes<HTMLAmplifyRequireNewPasswordElement>;
            "amplify-s3-album": LocalJSX.AmplifyS3Album & JSXBase.HTMLAttributes<HTMLAmplifyS3AlbumElement>;
            "amplify-s3-image": LocalJSX.AmplifyS3Image & JSXBase.HTMLAttributes<HTMLAmplifyS3ImageElement>;
            "amplify-s3-image-picker": LocalJSX.AmplifyS3ImagePicker & JSXBase.HTMLAttributes<HTMLAmplifyS3ImagePickerElement>;
            "amplify-s3-text": LocalJSX.AmplifyS3Text & JSXBase.HTMLAttributes<HTMLAmplifyS3TextElement>;
            "amplify-s3-text-picker": LocalJSX.AmplifyS3TextPicker & JSXBase.HTMLAttributes<HTMLAmplifyS3TextPickerElement>;
            "amplify-section": LocalJSX.AmplifySection & JSXBase.HTMLAttributes<HTMLAmplifySectionElement>;
            "amplify-select": LocalJSX.AmplifySelect & JSXBase.HTMLAttributes<HTMLAmplifySelectElement>;
            "amplify-select-mfa-type": LocalJSX.AmplifySelectMfaType & JSXBase.HTMLAttributes<HTMLAmplifySelectMfaTypeElement>;
            "amplify-sign-in": LocalJSX.AmplifySignIn & JSXBase.HTMLAttributes<HTMLAmplifySignInElement>;
            "amplify-sign-in-button": LocalJSX.AmplifySignInButton & JSXBase.HTMLAttributes<HTMLAmplifySignInButtonElement>;
            "amplify-sign-out": LocalJSX.AmplifySignOut & JSXBase.HTMLAttributes<HTMLAmplifySignOutElement>;
            "amplify-sign-up": LocalJSX.AmplifySignUp & JSXBase.HTMLAttributes<HTMLAmplifySignUpElement>;
            "amplify-strike": LocalJSX.AmplifyStrike & JSXBase.HTMLAttributes<HTMLAmplifyStrikeElement>;
            "amplify-toast": LocalJSX.AmplifyToast & JSXBase.HTMLAttributes<HTMLAmplifyToastElement>;
            "amplify-tooltip": LocalJSX.AmplifyTooltip & JSXBase.HTMLAttributes<HTMLAmplifyTooltipElement>;
            "amplify-totp-setup": LocalJSX.AmplifyTotpSetup & JSXBase.HTMLAttributes<HTMLAmplifyTotpSetupElement>;
            "amplify-username-field": LocalJSX.AmplifyUsernameField & JSXBase.HTMLAttributes<HTMLAmplifyUsernameFieldElement>;
            "amplify-verify-contact": LocalJSX.AmplifyVerifyContact & JSXBase.HTMLAttributes<HTMLAmplifyVerifyContactElement>;
        }
    }
}
